#
# Computer codes for the paper:
#  
# Hlavka, Huskova, Meintanis: Tests for independence in non-parametric heteroscedastic regression models,
# Journal of Multivariate Analysis 102 (2011) 816-827.
#
# Note: this definitions works only under linux
#       the C codes has to be compiled by typing
#          R CMD SHLIB nprind1.c
#          R CMD SHLIB nprind2.c
#       on the commandline
#
# Remark: these definitions do not include the tuning parameters
#         the test statistics from the paper (with parameters gamma1 and gamma2) may be obtained as 
#           cf1=nprind1(x/(sd(x)*gamma1),r/(sd(r)*gamma2))/(gamma1*gamma2*sd(x)*sd(r))
#           cf2=nprind1(x/(sd(x)*gamma1),r/(sd(r)*gamma2))/(gamma1*gamma2*sd(x)*sd(r))  
#
## definition of the test statistics CF1
nprind1 <- function (x,r) { 
  if (length(x)!=length(r)) stop("error in nprind1: both vectors must have same length!")
  .C("nprind1sq",x=as.double(x),e=as.double(r),n=as.integer(length(x)),n2=as.integer(length(x)^2),t=double(1))$t
}
dyn.load("./nprind1sq.so")
## definition of the test statistics CF2
nprind2 <- function (x,r) { 
  if (length(x)!=length(r)) stop("error in nprind: both vectors must have same length!")
  .C("nprind2sq",x=as.double(x),e=as.double(r),n=as.integer(length(x)),n2=as.integer(length(x)^2),t=double(1))$t
}
dyn.load("./nprind2sq.so")
